﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Net;
using System.IO;
using System.Security.Cryptography;
using System.Web.Script.Serialization;

namespace ExcelWsSession
{
    [ComVisible(true)]
    [ClassInterface(ClassInterfaceType.None)]
    public class Authenticator
    {
        public string AuthHeader(string username, string password, string url, string actor=null)
        {
            AuthToken auth = GetAuthToken(username, password);

            if (auth == null)
                return "Invalid Username or Password";

            string timestamp = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
            string message = url + timestamp;

            byte[] key = Encoding.UTF8.GetBytes(auth.SharedSecret);
            byte[] messageBytes = Encoding.UTF8.GetBytes(message);

            HMACSHA512 hmac = new HMACSHA512(key);
            byte[] hashValue = hmac.ComputeHash(messageBytes);

            string messageB64 = Convert.ToBase64String(hashValue);


            HttpWebRequest request = (HttpWebRequest)HttpWebRequest.Create(url);
            request.Method = "GET";
            string authHeader = "URL-Encoded-WsSession-Key " + auth.ApiKey + "," + messageB64 + "," + timestamp;

            if (actor != null)
                authHeader += "," + actor;

            return authHeader;
        }

        private AuthToken GetAuthToken(string username, string password)
        {
            HttpWebRequest req = (HttpWebRequest)HttpWebRequest.Create("https://ws.byu.edu/authentication/services/rest/v1/ws/session");
            req.Method = "POST";
            string body = string.Format("netId={0}&password={1}&timeout=1", username, password);
            Stream stream = req.GetRequestStream();
            StreamWriter writer = new StreamWriter(stream);
            writer.Write(body);
            writer.Close();
            HttpWebResponse response = (HttpWebResponse)req.GetResponse();
            stream = response.GetResponseStream();
            StreamReader reader = new StreamReader(stream);
            string line = reader.ReadToEnd();

            JavaScriptSerializer ser = new JavaScriptSerializer();
            return ser.Deserialize<AuthToken>(line);
        }
    }
}
